import { useEffect, useMemo } from 'react';
import { useStableCallback } from './use-stable-callback';
export function useResize(_ref) {
  var el = _ref.el,
    _ref$onResize = _ref.onResize,
    onResize = _ref$onResize === void 0 ? function () {} : _ref$onResize;
  var onResizeFn = useStableCallback(onResize);
  var obs = useMemo(function () {
    var fn = function fn(entries) {
      entries.forEach(function (entry) {
        onResizeFn === null || onResizeFn === void 0 ? void 0 : onResizeFn.call(null, entry);
      });
    };
    // 不推荐节流，动画会不连贯 throttle(fn, 300)
    return new ResizeObserver(fn);
  }, []);
  useEffect(function () {
    if (el) {
      // 开始监听
      obs.observe(el);
      return function () {
        obs.unobserve(el);
        obs.disconnect();
      };
    }
    return undefined;
  }, [obs, el]);
}